diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/client.h ircd-hybrid-6.0/include/client.h
--- ircd-hybrid-6.0.orig/include/client.h	Thu Jul  5 23:31:13 2001
+++ ircd-hybrid-6.0/include/client.h	Thu Jul  5 23:24:59 2001
@@ -296,8 +296,12 @@
   /*
    * XXX - there is no reason to save this, it should be checked when it's
    * received and not stored, this is not used after registration
+   *
+   * Now heavily (ab)used during challenge/reponse
+   *  -- asuffield
    */
   char              passwd[PASSWDLEN + 1];
+  char              response[32 + 1]; /* Size of a response field, used to buffer the response */
   int               caps;       /* capabilities bit-field */
   struct timeval    ping_send_time; /* When I last sent a ping */
   struct timeval    ping_time;      /* ping RTT */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/config.h ircd-hybrid-6.0/include/config.h
--- ircd-hybrid-6.0.orig/include/config.h	Thu Jul  5 23:31:13 2001
+++ ircd-hybrid-6.0/include/config.h	Thu Jul  5 23:24:59 2001
@@ -295,7 +295,7 @@
 /* MAX_PART_LENGTH
  * This is the maximum length of a PART reason
  */
-#define MAX_PART_LENGTH 64
+#define MAX_PART_LENGTH 128
 
 /* TIDY_QUIT
  * This prefixes "Reason: " onto all quit messages, and strips all colours
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/patchlevel.h ircd-hybrid-6.0/include/patchlevel.h
--- ircd-hybrid-6.0.orig/include/patchlevel.h	Thu Jul  5 23:31:13 2001
+++ ircd-hybrid-6.0/include/patchlevel.h	Thu Jul  5 23:30:56 2001
@@ -17,5 +17,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "dancer-ircd-0.9.3.5(rc2)"
+#define PATCHLEVEL    "dancer-ircd-0.9.3.6(rc3)"
 #endif
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/.depend ircd-hybrid-6.0/src/.depend
--- ircd-hybrid-6.0.orig/src/.depend	Wed Dec 29 03:28:47 1999
+++ ircd-hybrid-6.0/src/.depend	Thu Jul  5 23:24:59 2001
@@ -1,433 +1,501 @@
 blalloc.o: blalloc.c ../include/blalloc.h ../include/ircd_defs.h \
- ../include/config.h ../include/setup.h ../include/irc_string.h \
- ../include/s_log.h ../include/send.h
+  ../include/config.h ../include/setup.h ../include/irc_string.h \
+  ../include/s_log.h ../include/numeric.h ../include/send.h \
+  ../include/client.h ../include/dbuf.h
 channel.o: channel.c ../include/channel.h ../include/config.h \
- ../include/setup.h ../include/ircd_defs.h ../include/client.h \
- ../include/dbuf.h ../include/common.h ../include/hash.h \
- ../include/irc_string.h ../include/ircd.h ../include/list.h \
- ../include/numeric.h ../include/s_serv.h ../include/s_user.h \
- ../include/send.h ../include/struct.h ../include/whowas.h
+  ../include/setup.h ../include/ircd_defs.h ../include/client.h \
+  ../include/dbuf.h ../include/common.h ../include/hash.h \
+  ../include/irc_string.h ../include/ircd.h ../include/list.h \
+  ../include/numeric.h ../include/s_serv.h ../include/s_user.h \
+  ../include/s_log.h ../include/send.h ../include/struct.h \
+  ../include/whowas.h ../include/m_commands.h
 class.o: class.c ../include/class.h ../include/client.h \
- ../include/config.h ../include/setup.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/ircd.h \
- ../include/list.h ../include/numeric.h ../include/s_conf.h \
- ../include/fileio.h ../include/motd.h ../include/send.h \
- ../include/struct.h
+  ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/ircd.h \
+  ../include/list.h ../include/numeric.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/send.h \
+  ../include/struct.h ../include/s_debug.h
 client.o: client.c ../include/client.h ../include/config.h \
- ../include/setup.h ../include/ircd_defs.h ../include/dbuf.h \
- ../include/class.h ../include/blalloc.h ../include/channel.h \
- ../include/common.h ../include/dline_conf.h ../include/fdlist.h \
- ../include/hash.h ../include/irc_string.h ../include/ircd.h \
- ../include/list.h ../include/m_gline.h ../include/numeric.h \
- ../include/res.h ../include/s_bsd.h ../include/s_conf.h \
- ../include/fileio.h ../include/motd.h ../include/s_log.h \
- ../include/s_misc.h ../include/s_serv.h ../include/send.h \
- ../include/struct.h ../include/whowas.h
-dbuf.o: dbuf.c ../include/dbuf.h ../include/config.h \
- ../include/setup.h ../include/common.h ../include/irc_string.h
+  ../include/setup.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/class.h ../include/blalloc.h ../include/channel.h \
+  ../include/common.h ../include/dline_conf.h ../include/fdlist.h \
+  ../include/hash.h ../include/irc_string.h ../include/ircd.h \
+  ../include/list.h ../include/m_gline.h ../include/numeric.h \
+  ../include/res.h ../include/s_bsd.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_log.h \
+  ../include/s_misc.h ../include/s_serv.h ../include/send.h \
+  ../include/struct.h ../include/whowas.h ../include/s_debug.h \
+  ../include/s_user.h
+dbuf.o: dbuf.c ../include/dbuf.h ../include/config.h ../include/setup.h \
+  ../include/common.h ../include/irc_string.h ../include/ircd_defs.h
 dline_conf.o: dline_conf.c ../include/dline_conf.h ../include/class.h \
- ../include/client.h ../include/config.h ../include/setup.h \
- ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
- ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
- ../include/s_conf.h ../include/fileio.h ../include/motd.h \
- ../include/send.h ../include/struct.h
+  ../include/client.h ../include/config.h ../include/setup.h \
+  ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+  ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+  ../include/send.h ../include/struct.h
 fdlist.o: fdlist.c ../include/fdlist.h ../include/client.h \
- ../include/config.h ../include/setup.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/s_bsd.h
+  ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/s_bsd.h
 fileio.o: fileio.c ../include/fileio.h
-flud.o: flud.c ../include/flud.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
- ../include/list.h ../include/numeric.h ../include/send.h \
- ../include/channel.h ../include/struct.h ../include/blalloc.h \
- ../include/s_stats.h
-hash.o: hash.c ../include/s_conf.h ../include/config.h \
- ../include/setup.h ../include/fileio.h ../include/ircd_defs.h \
- ../include/motd.h ../include/channel.h ../include/client.h \
- ../include/dbuf.h ../include/common.h ../include/hash.h \
- ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
- ../include/send.h ../include/struct.h
-irc_string.o: irc_string.c ../include/irc_string.h ../include/list.h
-ircd.o: ircd.c ../include/ircd.h ../include/config.h \
- ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
- ../include/class.h ../include/client.h ../include/dbuf.h \
- ../include/common.h ../include/dline_conf.h ../include/fdlist.h \
- ../include/hash.h ../include/irc_string.h ../include/ircd_signal.h \
- ../include/list.h ../include/m_gline.h ../include/motd.h \
- ../include/msg.h ../include/mtrie_conf.h ../include/numeric.h \
- ../include/parse.h ../include/res.h ../include/restart.h \
- ../include/s_auth.h ../include/s_bsd.h ../include/s_conf.h \
- ../include/fileio.h ../include/s_debug.h ../include/s_log.h \
- ../include/s_misc.h ../include/s_serv.h ../include/s_stats.h \
- ../include/s_zip.h ../zlib/zlib.h ../zlib/zconf.h ../zlib/setup.h \
- ../include/scache.h ../include/send.h ../include/struct.h \
- ../include/whowas.h
-ircd_signal.o: ircd_signal.c ../include/ircd_signal.h \
- ../include/ircd.h ../include/config.h ../include/setup.h \
- ../include/restart.h ../include/s_log.h ../include/send.h
-list.o: list.c ../include/struct.h ../include/config.h \
- ../include/setup.h ../include/blalloc.h ../include/channel.h \
- ../include/ircd_defs.h ../include/class.h ../include/client.h \
- ../include/dbuf.h ../include/common.h ../include/irc_string.h \
- ../include/list.h ../include/mtrie_conf.h ../include/numeric.h \
- ../include/res.h ../include/restart.h ../include/s_log.h \
- ../include/send.h ../include/flud.h
+flud.o: flud.c ../include/flud.h ../include/config.h ../include/setup.h \
+  ../include/client.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/irc_string.h ../include/ircd.h ../include/list.h \
+  ../include/numeric.h ../include/send.h ../include/channel.h \
+  ../include/struct.h ../include/blalloc.h ../include/s_stats.h
+hash.o: hash.c ../include/s_conf.h ../include/config.h ../include/setup.h \
+  ../include/fileio.h ../include/ircd_defs.h ../include/motd.h \
+  ../include/client.h ../include/dbuf.h ../include/channel.h \
+  ../include/common.h ../include/hash.h ../include/irc_string.h \
+  ../include/ircd.h ../include/numeric.h ../include/send.h \
+  ../include/struct.h ../include/s_debug.h
+irc_string.o: irc_string.c ../include/irc_string.h ../include/ircd_defs.h \
+  ../include/config.h ../include/setup.h ../include/list.h
+ircd.o: ircd.c ../include/ircd.h ../include/config.h ../include/setup.h \
+  ../include/channel.h ../include/ircd_defs.h ../include/class.h \
+  ../include/client.h ../include/dbuf.h ../include/common.h \
+  ../include/dline_conf.h ../include/fdlist.h ../include/hash.h \
+  ../include/irc_string.h ../include/ircd_signal.h ../include/list.h \
+  ../include/m_gline.h ../include/motd.h ../include/msg.h \
+  ../include/mtrie_conf.h ../include/numeric.h ../include/parse.h \
+  ../include/res.h ../include/restart.h ../include/s_auth.h \
+  ../include/s_bsd.h ../include/s_cr.h ../include/s_conf.h \
+  ../include/fileio.h ../include/s_debug.h ../include/s_log.h \
+  ../include/s_misc.h ../include/s_serv.h ../include/s_stats.h \
+  ../include/s_zip.h ../zlib/zlib.h ../zlib/zconf.h ../zlib/setup.h \
+  ../include/scache.h ../include/send.h ../include/struct.h \
+  ../include/whowas.h ../include/s_user.h
+ircd_signal.o: ircd_signal.c ../include/ircd_signal.h ../include/ircd.h \
+  ../include/config.h ../include/setup.h ../include/restart.h \
+  ../include/s_log.h ../include/send.h
+list.o: list.c ../include/struct.h ../include/config.h ../include/setup.h \
+  ../include/blalloc.h ../include/channel.h ../include/ircd_defs.h \
+  ../include/class.h ../include/client.h ../include/dbuf.h \
+  ../include/common.h ../include/irc_string.h ../include/list.h \
+  ../include/mtrie_conf.h ../include/numeric.h ../include/res.h \
+  ../include/restart.h ../include/s_log.h ../include/send.h \
+  ../include/flud.h
 listener.o: listener.c ../include/listener.h ../include/ircd_defs.h \
- ../include/config.h ../include/setup.h ../include/client.h \
- ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/s_bsd.h ../include/s_conf.h \
- ../include/fileio.h ../include/motd.h ../include/s_stats.h \
- ../include/send.h ../include/struct.h
+  ../include/config.h ../include/setup.h ../include/client.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_bsd.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_stats.h \
+  ../include/send.h ../include/struct.h
 m_admin.o: m_admin.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_conf.h ../include/fileio.h ../include/motd.h \
- ../include/s_serv.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+  ../include/s_serv.h ../include/send.h
 m_away.o: m_away.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/send.h
 m_capab.o: m_capab.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/irc_string.h ../include/s_serv.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/s_serv.h
+m_chall.o: m_chall.c ../include/m_commands.h ../include/config.h \
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/send.h \
+  ../include/numeric.h ../include/ircd.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_log.h \
+  ../include/s_cr.h ../include/common.h ../include/s_serv.h
 m_close.o: m_close.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_bsd.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_bsd.h ../include/send.h
 m_connect.o: m_connect.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/ircd.h \
- ../include/irc_string.h ../include/numeric.h ../include/s_bsd.h \
- ../include/s_conf.h ../include/fileio.h ../include/motd.h \
- ../include/s_log.h ../include/s_serv.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/ircd.h \
+  ../include/irc_string.h ../include/numeric.h ../include/s_bsd.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+  ../include/s_log.h ../include/s_serv.h ../include/send.h
+md5.o: md5.c ../include/md5.h
+md5crypt.o: md5crypt.c ../include/md5.h ../include/s_log.h
 m_die.o: m_die.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/irc_string.h \
- ../include/numeric.h ../include/s_bsd.h ../include/s_log.h \
- ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/irc_string.h \
+  ../include/numeric.h ../include/s_bsd.h ../include/s_log.h \
+  ../include/send.h
 m_error.o: m_error.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/ircd.h \
- ../include/numeric.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/ircd.h \
+  ../include/numeric.h ../include/send.h ../include/s_debug.h
 m_gline.o: m_gline.c ../include/m_gline.h ../include/config.h \
- ../include/setup.h ../include/ircd_defs.h ../include/channel.h \
- ../include/client.h ../include/dbuf.h ../include/common.h \
- ../include/dline_conf.h ../include/irc_string.h ../include/ircd.h \
- ../include/m_kline.h ../include/mtrie_conf.h ../include/numeric.h \
- ../include/s_conf.h ../include/fileio.h ../include/motd.h \
- ../include/s_misc.h ../include/scache.h ../include/send.h \
- ../include/struct.h
+  ../include/setup.h ../include/ircd_defs.h ../include/channel.h \
+  ../include/client.h ../include/dbuf.h ../include/common.h \
+  ../include/dline_conf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/m_kline.h ../include/mtrie_conf.h ../include/numeric.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+  ../include/s_misc.h ../include/scache.h ../include/send.h \
+  ../include/struct.h
 m_htm.o: m_htm.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/irc_string.h \
- ../include/ircd.h ../include/numeric.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/irc_string.h \
+  ../include/ircd.h ../include/numeric.h ../include/send.h
 m_info.o: m_info.c ../include/m_info.h ../include/config.h \
- ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
- ../include/client.h ../include/dbuf.h ../include/common.h \
- ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/s_user.h ../include/send.h \
- ../include/struct.h
+  ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
+  ../include/client.h ../include/dbuf.h ../include/common.h \
+  ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/s_user.h ../include/send.h \
+  ../include/struct.h
 m_ison.o: m_ison.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/send.h
 m_help.o: m_help.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/motd.h \
- ../include/msg.h ../include/numeric.h ../include/send.h \
- ../include/s_conf.h ../include/fileio.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/motd.h ../include/msg.h \
+  ../include/numeric.h ../include/send.h ../include/s_conf.h \
+  ../include/fileio.h
 m_kill.o: m_kill.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_log.h ../include/s_serv.h ../include/send.h \
- ../include/whowas.h ../include/irc_string.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_log.h ../include/s_serv.h ../include/send.h \
+  ../include/whowas.h ../include/irc_string.h
 m_kline.o: m_kline.c ../include/m_kline.h ../include/channel.h \
- ../include/config.h ../include/setup.h ../include/ircd_defs.h \
- ../include/class.h ../include/client.h ../include/dbuf.h \
- ../include/common.h ../include/dline_conf.h ../include/irc_string.h \
- ../include/ircd.h ../include/mtrie_conf.h ../include/numeric.h \
- ../include/s_conf.h ../include/fileio.h ../include/motd.h \
- ../include/s_log.h ../include/s_misc.h ../include/send.h \
- ../include/struct.h ../include/hash.h
+  ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+  ../include/class.h ../include/client.h ../include/dbuf.h \
+  ../include/common.h ../include/dline_conf.h ../include/irc_string.h \
+  ../include/ircd.h ../include/mtrie_conf.h ../include/numeric.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+  ../include/s_log.h ../include/s_misc.h ../include/send.h \
+  ../include/struct.h ../include/hash.h
 m_links.o: m_links.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/s_serv.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_serv.h ../include/send.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h
 m_list.o: m_list.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
- ../include/client.h ../include/dbuf.h ../include/hash.h \
- ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
- ../include/send.h
+  ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
+  ../include/client.h ../include/dbuf.h ../include/hash.h \
+  ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
+  ../include/send.h
 m_locops.o: m_locops.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/irc_string.h \
- ../include/numeric.h ../include/send.h ../include/s_user.h \
- ../include/s_conf.h ../include/fileio.h ../include/motd.h \
- ../include/hash.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/irc_string.h \
+  ../include/numeric.h ../include/send.h ../include/s_user.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+  ../include/hash.h
 m_ltrace.o: m_ltrace.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/class.h ../include/client.h \
- ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
- ../include/hash.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/s_bsd.h ../include/s_serv.h \
- ../include/send.h
+  ../include/setup.h ../include/class.h ../include/client.h \
+  ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+  ../include/hash.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_bsd.h ../include/s_serv.h \
+  ../include/send.h
 m_lusers.o: m_lusers.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/s_user.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/s_user.h ../include/send.h
+m_makepass.o: m_makepass.c ../include/common.h /usr/include/assert.h \
+  ../include/m_commands.h ../include/config.h ../include/setup.h \
+  ../include/client.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/ircd.h ../include/numeric.h ../include/send.h \
+  ../include/channel.h ../include/irc_string.h ../include/s_debug.h
 m_message.o: m_message.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/flud.h ../include/ircd.h \
- ../include/numeric.h ../include/s_serv.h ../include/send.h \
- ../include/msg.h ../include/channel.h ../include/irc_string.h \
- ../include/hash.h ../include/class.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/flud.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_serv.h ../include/send.h \
+  ../include/msg.h ../include/channel.h ../include/irc_string.h \
+  ../include/hash.h ../include/class.h ../include/s_user.h
 m_mode.o: m_mode.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
- ../include/client.h ../include/dbuf.h ../include/hash.h \
- ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
- ../include/s_user.h ../include/send.h
+  ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
+  ../include/client.h ../include/dbuf.h ../include/hash.h \
+  ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_user.h ../include/send.h
 m_operwall.o: m_operwall.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/irc_string.h \
- ../include/numeric.h ../include/send.h ../include/s_user.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/irc_string.h \
+  ../include/numeric.h ../include/send.h ../include/s_user.h
 m_oper.o: m_oper.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/fdlist.h ../include/irc_string.h \
- ../include/ircd.h ../include/numeric.h ../include/s_conf.h \
- ../include/fileio.h ../include/motd.h ../include/s_log.h \
- ../include/s_user.h ../include/send.h ../include/struct.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/fdlist.h ../include/irc_string.h \
+  ../include/ircd.h ../include/numeric.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_log.h \
+  ../include/s_user.h ../include/send.h ../include/struct.h
 m_pass.o: m_pass.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/irc_string.h ../include/send.h \
- ../include/numeric.h ../include/ircd.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/send.h \
+  ../include/numeric.h ../include/ircd.h
 m_ping.o: m_ping.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/send.h ../include/irc_string.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/send.h ../include/irc_string.h
 m_pong.o: m_pong.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/send.h ../include/channel.h ../include/irc_string.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/send.h ../include/channel.h ../include/irc_string.h \
+  ../include/s_debug.h ../include/s_log.h
 m_quit.o: m_quit.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/send.h /usr/include/ctype.h \
+  ../include/irc_string.h
 m_rehash.o: m_rehash.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/irc_string.h \
- ../include/ircd.h ../include/list.h ../include/m_gline.h \
- ../include/numeric.h ../include/res.h ../include/s_conf.h \
- ../include/fileio.h ../include/motd.h ../include/s_log.h \
- ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/irc_string.h \
+  ../include/ircd.h ../include/list.h ../include/m_gline.h \
+  ../include/numeric.h ../include/res.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_log.h \
+  ../include/send.h
+m_resp.o: m_resp.c ../include/m_commands.h ../include/config.h \
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/send.h \
+  ../include/numeric.h ../include/ircd.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_log.h \
+  ../include/s_cr.h ../include/common.h ../include/s_serv.h
 m_restart.o: m_restart.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/irc_string.h \
- ../include/ircd.h ../include/numeric.h ../include/restart.h \
- ../include/s_log.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/irc_string.h \
+  ../include/ircd.h ../include/numeric.h ../include/restart.h \
+  ../include/s_log.h ../include/send.h
+m_services.o: m_services.c ../include/m_commands.h ../include/config.h \
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_misc.h ../include/s_serv.h ../include/send.h
 m_server.o: m_server.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/hash.h \
- ../include/irc_string.h ../include/ircd.h ../include/list.h \
- ../include/numeric.h ../include/s_conf.h ../include/fileio.h \
- ../include/motd.h ../include/s_serv.h ../include/s_stats.h \
- ../include/scache.h ../include/send.h ../include/struct.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/hash.h \
+  ../include/irc_string.h ../include/ircd.h ../include/list.h \
+  ../include/numeric.h ../include/s_conf.h ../include/fileio.h \
+  ../include/motd.h ../include/s_serv.h ../include/s_stats.h \
+  ../include/scache.h ../include/send.h ../include/struct.h
 m_set.o: m_set.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/s_bsd.h ../include/s_serv.h \
- ../include/send.h ../include/common.h ../include/channel.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_bsd.h ../include/s_serv.h \
+  ../include/send.h ../include/common.h ../include/channel.h \
+  ../include/s_log.h
+m_setname.o: m_setname.c ../include/common.h /usr/include/assert.h \
+  ../include/m_commands.h ../include/config.h ../include/setup.h \
+  ../include/client.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/ircd.h ../include/numeric.h ../include/send.h \
+  ../include/channel.h ../include/irc_string.h ../include/s_debug.h
 m_squit.o: m_squit.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/irc_string.h \
- ../include/ircd.h ../include/numeric.h ../include/s_conf.h \
- ../include/fileio.h ../include/motd.h ../include/s_log.h \
- ../include/s_serv.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/irc_string.h \
+  ../include/ircd.h ../include/numeric.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_log.h \
+  ../include/s_serv.h ../include/send.h
 m_stats.o: m_stats.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/class.h ../include/client.h \
- ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
- ../include/dline_conf.h ../include/irc_string.h ../include/ircd.h \
- ../include/listener.h ../include/msg.h ../include/mtrie_conf.h \
- ../include/m_gline.h ../include/numeric.h ../include/scache.h \
- ../include/send.h ../include/s_bsd.h ../include/s_conf.h \
- ../include/fileio.h ../include/motd.h ../include/s_debug.h \
- ../include/s_misc.h ../include/s_serv.h ../include/s_stats.h \
- ../include/s_user.h
+  ../include/setup.h ../include/class.h ../include/client.h \
+  ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+  ../include/dline_conf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/listener.h ../include/msg.h ../include/mtrie_conf.h \
+  ../include/m_gline.h ../include/numeric.h ../include/scache.h \
+  ../include/send.h ../include/s_bsd.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_debug.h \
+  ../include/s_misc.h ../include/s_serv.h ../include/s_stats.h \
+  ../include/s_user.h
+m_stopic.o: m_stopic.c ../include/m_commands.h ../include/config.h \
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/channel.h ../include/hash.h \
+  ../include/struct.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/send.h ../include/list.h \
+  ../include/irc_string.h
 m_svinfo.o: m_svinfo.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/irc_string.h \
- ../include/ircd.h ../include/numeric.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/irc_string.h \
+  ../include/ircd.h ../include/numeric.h ../include/send.h
 m_time.o: m_time.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_misc.h ../include/s_serv.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_misc.h ../include/s_serv.h ../include/send.h
 m_trace.o: m_trace.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/class.h ../include/client.h \
- ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
- ../include/hash.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/s_bsd.h ../include/s_serv.h \
- ../include/send.h
+  ../include/setup.h ../include/class.h ../include/client.h \
+  ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+  ../include/hash.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_bsd.h ../include/s_serv.h \
+  ../include/send.h
 m_unkline.o: m_unkline.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
- ../include/client.h ../include/dbuf.h ../include/common.h \
- ../include/dline_conf.h ../include/fileio.h ../include/irc_string.h \
- ../include/ircd.h ../include/mtrie_conf.h ../include/numeric.h \
- ../include/s_conf.h ../include/motd.h ../include/s_log.h \
- ../include/s_misc.h ../include/send.h ../include/struct.h
+  ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
+  ../include/client.h ../include/dbuf.h ../include/common.h \
+  ../include/dline_conf.h ../include/fileio.h ../include/irc_string.h \
+  ../include/ircd.h ../include/mtrie_conf.h ../include/numeric.h \
+  ../include/s_conf.h ../include/motd.h ../include/s_log.h \
+  ../include/s_misc.h ../include/send.h ../include/struct.h
 m_userhost.o: m_userhost.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/send.h ../include/irc_string.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/send.h ../include/irc_string.h
 m_users.o: m_users.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/send.h
 m_version.o: m_version.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/send.h
 m_wallops.o: m_wallops.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/ircd.h ../include/irc_string.h \
- ../include/numeric.h ../include/send.h ../include/s_user.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/irc_string.h \
+  ../include/numeric.h ../include/send.h ../include/s_user.h
 m_who.o: m_who.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/channel.h ../include/hash.h \
- ../include/struct.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/send.h ../include/list.h \
- ../include/irc_string.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/channel.h ../include/hash.h \
+  ../include/struct.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/send.h ../include/list.h \
+  ../include/irc_string.h
 m_whois.o: m_whois.c ../include/m_commands.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/channel.h ../include/hash.h \
- ../include/struct.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/send.h ../include/list.h \
- ../include/irc_string.h
-match.o: match.c ../include/irc_string.h ../include/config.h \
- ../include/setup.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/channel.h ../include/hash.h \
+  ../include/struct.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/send.h ../include/list.h \
+  ../include/irc_string.h ../include/s_conf.h ../include/fileio.h \
+  ../include/motd.h
+match.o: match.c ../include/irc_string.h ../include/ircd_defs.h \
+  ../include/config.h ../include/setup.h
 motd.o: motd.c ../include/motd.h ../include/ircd_defs.h \
- ../include/config.h ../include/setup.h ../include/ircd.h \
- ../include/s_bsd.h ../include/fileio.h ../include/res.h \
- ../include/s_conf.h ../include/class.h ../include/send.h \
- ../include/numeric.h ../include/client.h ../include/dbuf.h \
- ../include/irc_string.h ../include/s_serv.h
+  ../include/config.h ../include/setup.h ../include/ircd.h \
+  ../include/s_bsd.h ../include/fileio.h ../include/res.h \
+  ../include/s_conf.h ../include/client.h ../include/dbuf.h \
+  ../include/class.h ../include/send.h ../include/numeric.h \
+  ../include/irc_string.h ../include/s_serv.h
 mtrie_conf.o: mtrie_conf.c ../include/mtrie_conf.h ../include/class.h \
- ../include/client.h ../include/config.h ../include/setup.h \
- ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
- ../include/dline_conf.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/s_conf.h ../include/fileio.h \
- ../include/motd.h ../include/send.h ../include/struct.h
+  ../include/client.h ../include/config.h ../include/setup.h \
+  ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+  ../include/dline_conf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_conf.h ../include/fileio.h \
+  ../include/motd.h ../include/send.h ../include/struct.h \
+  ../include/m_commands.h
 oratime.o: oratime.c ../include/oratime.h ../include/config.h \
- ../include/setup.h
+  ../include/setup.h
 numeric.o: numeric.c ../include/numeric.h ../include/config.h \
- ../include/setup.h ../include/irc_string.h ../include/common.h \
- messages.tab
+  ../include/setup.h ../include/irc_string.h ../include/ircd_defs.h \
+  ../include/common.h messages_cust.tab
 packet.o: packet.c ../include/packet.h ../include/client.h \
- ../include/config.h ../include/setup.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/ircd.h \
- ../include/list.h ../include/parse.h ../include/s_zip.h \
- ../zlib/zlib.h ../zlib/zconf.h ../zlib/setup.h ../include/struct.h
+  ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/ircd.h \
+  ../include/list.h ../include/parse.h ../include/s_zip.h ../zlib/zlib.h \
+  ../zlib/zconf.h ../zlib/setup.h ../include/struct.h \
+  ../include/irc_string.h
 parse.o: parse.c ../include/parse.h ../include/channel.h \
- ../include/config.h ../include/setup.h ../include/ircd_defs.h \
- ../include/client.h ../include/dbuf.h ../include/common.h \
- ../include/hash.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/s_log.h ../include/s_stats.h \
- ../include/send.h ../include/struct.h ../include/msg.h \
- ../include/m_commands.h
+  ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+  ../include/client.h ../include/dbuf.h ../include/common.h \
+  ../include/hash.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_log.h ../include/s_stats.h \
+  ../include/send.h ../include/struct.h ../include/s_debug.h \
+  ../include/msg.h ../include/m_commands.h
 res.o: res.c ../include/res.h ../include/client.h ../include/config.h \
- ../include/setup.h ../include/ircd_defs.h ../include/dbuf.h \
- ../include/common.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/restart.h ../include/s_bsd.h \
- ../include/send.h ../include/struct.h
+  ../include/setup.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/common.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/restart.h ../include/s_bsd.h \
+  ../include/send.h ../include/struct.h ../include/s_debug.h
 restart.o: restart.c ../include/restart.h ../include/common.h \
- ../include/ircd.h ../include/config.h ../include/setup.h \
- ../include/send.h ../include/struct.h ../include/s_debug.h \
- ../include/s_log.h
+  ../include/ircd.h ../include/config.h ../include/setup.h \
+  ../include/send.h ../include/struct.h ../include/s_debug.h \
+  ../include/s_log.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h
 s_auth.o: s_auth.c ../include/s_auth.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/fdlist.h \
- ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
- ../include/res.h ../include/s_bsd.h ../include/s_log.h \
- ../include/s_stats.h ../include/send.h ../include/struct.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/fdlist.h \
+  ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
+  ../include/res.h ../include/s_bsd.h ../include/s_log.h \
+  ../include/s_stats.h ../include/send.h ../include/struct.h
 s_bsd.o: s_bsd.c ../include/s_bsd.h ../include/class.h \
- ../include/client.h ../include/config.h ../include/setup.h \
- ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
- ../include/fdlist.h ../include/irc_string.h ../include/ircd.h \
- ../include/list.h ../include/listener.h ../include/numeric.h \
- ../include/packet.h ../include/res.h ../include/restart.h \
- ../include/s_auth.h ../include/s_conf.h ../include/fileio.h \
- ../include/motd.h ../include/s_log.h ../include/s_serv.h \
- ../include/s_stats.h ../include/s_zip.h ../zlib/zlib.h \
- ../zlib/zconf.h ../zlib/setup.h ../include/send.h ../include/struct.h
+  ../include/client.h ../include/config.h ../include/setup.h \
+  ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+  ../include/fdlist.h ../include/irc_string.h ../include/ircd.h \
+  ../include/list.h ../include/listener.h ../include/numeric.h \
+  ../include/packet.h ../include/res.h ../include/restart.h \
+  ../include/s_auth.h ../include/s_conf.h ../include/fileio.h \
+  ../include/motd.h ../include/s_cr.h ../include/s_log.h \
+  ../include/s_serv.h ../include/s_stats.h ../include/s_zip.h \
+  ../zlib/zlib.h ../zlib/zconf.h ../zlib/setup.h ../include/s_debug.h \
+  ../include/send.h ../include/struct.h
+s_cr.o: s_cr.c ../include/client.h ../include/config.h ../include/setup.h \
+  ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+  ../include/s_log.h ../include/irc_string.h ../include/s_bsd.h \
+  ../include/ircd.h ../include/send.h ../include/md5.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+  ../include/s_serv.h
 s_conf.o: s_conf.c ../include/s_conf.h ../include/config.h \
- ../include/setup.h ../include/fileio.h ../include/ircd_defs.h \
- ../include/motd.h ../include/channel.h ../include/class.h \
- ../include/client.h ../include/dbuf.h ../include/common.h \
- ../include/dline_conf.h ../include/hash.h ../include/irc_string.h \
- ../include/ircd.h ../include/list.h ../include/listener.h \
- ../include/mtrie_conf.h ../include/numeric.h ../include/res.h \
- ../include/s_bsd.h ../include/s_log.h ../include/send.h \
- ../include/struct.h
+  ../include/setup.h ../include/fileio.h ../include/ircd_defs.h \
+  ../include/motd.h ../include/client.h ../include/dbuf.h \
+  ../include/channel.h ../include/class.h ../include/common.h \
+  ../include/dline_conf.h ../include/hash.h ../include/irc_string.h \
+  ../include/ircd.h ../include/list.h ../include/listener.h \
+  ../include/mtrie_conf.h ../include/numeric.h ../include/res.h \
+  ../include/s_bsd.h ../include/s_log.h ../include/send.h \
+  ../include/struct.h ../include/s_debug.h ../include/umodes.h
 s_debug.o: s_debug.c ../include/s_debug.h ../include/channel.h \
- ../include/config.h ../include/setup.h ../include/ircd_defs.h \
- ../include/class.h ../include/client.h ../include/dbuf.h \
- ../include/common.h ../include/hash.h ../include/ircd.h \
- ../include/list.h ../include/numeric.h ../include/res.h \
- ../include/s_conf.h ../include/fileio.h ../include/motd.h \
- ../include/s_log.h ../include/scache.h ../include/send.h \
- ../include/struct.h
+  ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+  ../include/class.h ../include/client.h ../include/dbuf.h \
+  ../include/common.h ../include/hash.h ../include/ircd.h \
+  ../include/list.h ../include/numeric.h ../include/res.h \
+  ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+  ../include/s_log.h ../include/scache.h ../include/send.h \
+  ../include/struct.h
 s_log.o: s_log.c ../include/s_log.h ../include/irc_string.h \
- ../include/ircd.h ../include/config.h ../include/setup.h \
- ../include/s_misc.h
+  ../include/ircd_defs.h ../include/config.h ../include/setup.h \
+  ../include/ircd.h ../include/s_misc.h
 s_misc.o: s_misc.c ../include/s_misc.h ../include/client.h \
- ../include/config.h ../include/setup.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/irc_string.h \
- ../include/ircd.h ../include/numeric.h ../include/res.h \
- ../include/s_bsd.h ../include/s_conf.h ../include/fileio.h \
- ../include/motd.h ../include/s_serv.h ../include/send.h \
- ../include/struct.h
+  ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/common.h ../include/irc_string.h \
+  ../include/ircd.h ../include/numeric.h ../include/res.h \
+  ../include/s_bsd.h ../include/s_conf.h ../include/fileio.h \
+  ../include/motd.h ../include/s_serv.h ../include/send.h \
+  ../include/struct.h
 s_serv.o: s_serv.c ../include/s_serv.h ../include/config.h \
- ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
- ../include/class.h ../include/client.h ../include/dbuf.h \
- ../include/common.h ../include/fdlist.h ../include/hash.h \
- ../include/irc_string.h ../include/ircd.h ../include/list.h \
- ../include/numeric.h ../include/res.h ../include/struct.h \
- ../include/s_bsd.h ../include/s_conf.h ../include/fileio.h \
- ../include/motd.h ../include/s_stats.h ../include/s_user.h \
- ../include/s_zip.h ../zlib/zlib.h ../zlib/zconf.h ../zlib/setup.h \
- ../include/scache.h ../include/send.h
+  ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
+  ../include/class.h ../include/client.h ../include/dbuf.h \
+  ../include/common.h ../include/fdlist.h ../include/hash.h \
+  ../include/irc_string.h ../include/ircd.h ../include/list.h \
+  ../include/numeric.h ../include/res.h ../include/struct.h \
+  ../include/s_bsd.h ../include/s_conf.h ../include/fileio.h \
+  ../include/motd.h ../include/s_log.h ../include/s_stats.h \
+  ../include/s_user.h ../include/s_zip.h ../zlib/zlib.h ../zlib/zconf.h \
+  ../zlib/setup.h ../include/scache.h ../include/send.h \
+  ../include/s_debug.h
 s_stats.o: s_stats.c ../include/s_stats.h ../include/config.h \
- ../include/setup.h ../include/client.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/s_bsd.h ../include/send.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/s_bsd.h ../include/send.h
 s_user.o: s_user.c ../include/s_user.h ../include/config.h \
- ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
- ../include/class.h ../include/client.h ../include/dbuf.h \
- ../include/common.h ../include/fdlist.h ../include/flud.h \
- ../include/hash.h ../include/irc_string.h ../include/ircd.h \
- ../include/list.h ../include/listener.h ../include/motd.h \
- ../include/msg.h ../include/numeric.h ../include/s_bsd.h \
- ../include/s_conf.h ../include/fileio.h ../include/s_log.h \
- ../include/s_serv.h ../include/s_stats.h ../include/scache.h \
- ../include/send.h ../include/struct.h ../include/whowas.h
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/channel.h ../include/class.h \
+  ../include/common.h ../include/fdlist.h ../include/flud.h \
+  ../include/hash.h ../include/irc_string.h ../include/ircd.h \
+  ../include/list.h ../include/listener.h ../include/motd.h \
+  ../include/msg.h ../include/numeric.h ../include/s_bsd.h \
+  ../include/s_conf.h ../include/fileio.h ../include/s_log.h \
+  ../include/s_serv.h ../include/s_stats.h ../include/scache.h \
+  ../include/send.h ../include/struct.h ../include/whowas.h \
+  ../include/umodes.h ../include/mtrie_conf.h
 s_zip.o: s_zip.c ../include/s_zip.h ../include/config.h \
- ../include/setup.h ../zlib/zlib.h ../zlib/zconf.h ../zlib/setup.h \
- ../include/client.h ../include/ircd_defs.h ../include/dbuf.h \
- ../include/irc_string.h ../include/packet.h ../include/s_bsd.h \
- ../include/s_serv.h ../include/send.h ../include/struct.h
+  ../include/setup.h ../zlib/zlib.h ../zlib/zconf.h ../zlib/setup.h \
+  ../include/client.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/irc_string.h ../include/packet.h ../include/s_bsd.h \
+  ../include/s_serv.h ../include/send.h ../include/struct.h
 scache.o: scache.c ../include/client.h ../include/config.h \
- ../include/setup.h ../include/ircd_defs.h ../include/dbuf.h \
- ../include/common.h ../include/irc_string.h ../include/ircd.h \
- ../include/numeric.h ../include/send.h ../include/struct.h
-send.o: send.c ../include/send.h ../include/config.h \
- ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
- ../include/class.h ../include/client.h ../include/dbuf.h \
- ../include/common.h ../include/irc_string.h ../include/ircd.h \
- ../include/m_commands.h ../include/numeric.h ../include/s_bsd.h \
- ../include/s_serv.h ../include/s_zip.h ../zlib/zlib.h ../zlib/zconf.h \
- ../zlib/setup.h ../include/sprintf_irc.h ../include/struct.h \
- ../include/s_conf.h ../include/fileio.h ../include/motd.h
+  ../include/setup.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/common.h ../include/irc_string.h ../include/ircd.h \
+  ../include/numeric.h ../include/send.h ../include/struct.h
+send.o: send.c ../include/send.h ../include/config.h ../include/setup.h \
+  ../include/channel.h ../include/ircd_defs.h ../include/class.h \
+  ../include/client.h ../include/dbuf.h ../include/common.h \
+  ../include/irc_string.h ../include/ircd.h ../include/m_commands.h \
+  ../include/numeric.h ../include/s_bsd.h ../include/s_serv.h \
+  ../include/s_zip.h ../zlib/zlib.h ../zlib/zconf.h ../zlib/setup.h \
+  ../include/sprintf_irc.h ../include/struct.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h ../include/s_debug.h \
+  ../include/s_log.h
 sprintf_irc.o: sprintf_irc.c ../include/sprintf_irc.h
+m_map.o: m_map.c ../include/client.h ../include/config.h \
+  ../include/setup.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/ircd.h ../include/common.h ../include/numeric.h \
+  ../include/irc_string.h ../include/send.h ../include/s_conf.h \
+  ../include/fileio.h ../include/motd.h
 whowas.o: whowas.c ../include/whowas.h ../include/ircd_defs.h \
- ../include/config.h ../include/setup.h ../include/client.h \
- ../include/dbuf.h ../include/common.h ../include/hash.h \
- ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
- ../include/s_serv.h ../include/s_user.h ../include/send.h \
- ../include/struct.h
+  ../include/config.h ../include/setup.h ../include/client.h \
+  ../include/dbuf.h ../include/common.h ../include/hash.h \
+  ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
+  ../include/s_serv.h ../include/s_user.h ../include/send.h \
+  ../include/struct.h
+tsdelta.o: tsdelta.c ../include/config.h ../include/setup.h \
+  ../include/client.h ../include/ircd_defs.h ../include/dbuf.h \
+  ../include/ircd.h ../include/common.h ../include/numeric.h \
+  ../include/irc_string.h ../include/send.h ../include/s_serv.h
+m_spingtime.o: m_spingtime.c ../include/m_commands.h ../include/config.h \
+  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+  ../include/dbuf.h ../include/ircd.h ../include/send.h \
+  ../include/numeric.h
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/channel.c ircd-hybrid-6.0/src/channel.c
--- ircd-hybrid-6.0.orig/src/channel.c	Thu Jul  5 23:31:13 2001
+++ ircd-hybrid-6.0/src/channel.c	Thu Jul  5 23:24:59 2001
@@ -3367,7 +3367,7 @@
 
 #ifdef ANTI_SPAMBOT       /* Dianora */
 
-          if( MyConnect(sptr) && !IsImmune(sptr) )
+          if( MyConnect(sptr) && !NoFloodProtection(sptr) )
             {
               if(SPAMNUM && (sptr->join_leave_count >= SPAMNUM))
                 {
@@ -3688,7 +3688,7 @@
 #ifdef ANTI_SPAMBOT     /* Dianora */
       /* if its my client, and isn't an oper */
 
-      if (name && MyConnect(sptr) && !IsImmune(sptr))
+      if (name && MyConnect(sptr) && !NoFloodProtection(sptr))
         {
           if(SPAMNUM && (sptr->join_leave_count >= SPAMNUM))
             {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_chall.c ircd-hybrid-6.0/src/m_chall.c
--- ircd-hybrid-6.0.orig/src/m_chall.c	Thu Jul  5 23:31:13 2001
+++ ircd-hybrid-6.0/src/m_chall.c	Thu Jul  5 23:24:59 2001
@@ -75,8 +75,9 @@
 
 int m_chall(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
 {
-  char* salt = parc > 3 ? parv[3] : "";
-  char* chall = parc > 2 ? parv[2] : "";
+  char* salt = parc > 4 ? parv[4] : "";
+  char* chall = parc > 3 ? parv[3] : "";
+  char* remote_host = parc > 2 ? parv[2] : "";
   char* host = parc > 1 ? parv[1] : "";
   struct ConfItem *n_conf, *c_conf;
   struct Client* acptr;
@@ -101,11 +102,19 @@
   if (IsPerson(cptr) || IsServer(cptr)) 
     return 0;
 
+  /* What are they trying to auth against, is it me? */
+  if (irccmp(remote_host, me.name) != 0)
+    {
+      sendto_one(cptr, "ERROR :I am %s, not %s", me.name, remote_host);
+      sendto_ops_flag(UMODE_SEEROUTING, "Server claiming to be %s challenged thinking I was %s, rejected", host, remote_host);
+      return exit_client(cptr, cptr, &me, "Sorry, wrong number");
+    }
+
   if ((acptr = find_server(host)))
     {
       sendto_one(cptr,"ERROR :Server %s already exists", host);
       if (!(acptr->from->caps & CAP_SERVICES)) /* If it's connected to services, it's actually a server jupe. Silently ignore. */
-	sendto_ops_flag(UMODE_SERVNOTICE, "Challenge for %s rejected, server already exists",
+	sendto_ops_flag(UMODE_EXTERNAL, "Challenge for %s rejected, server already exists",
 			host);
       return exit_client(cptr, cptr, &me, "Server already exists");
     }
@@ -150,9 +159,9 @@
   cr_sendresponse(cptr, c_conf, chall, salt);
 
   /* check for TS as in m_pass */
-  if (parc > 4)
+  if (parc > 5)
     {
-      if (0 == irccmp(parv[4], "TS"))
+      if (0 == irccmp(parv[5], "TS"))
         cptr->tsinfo = TS_DOESTS;
     }
   return 0;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_kline.c ircd-hybrid-6.0/src/m_kline.c
--- ircd-hybrid-6.0.orig/src/m_kline.c	Thu Jul  5 23:31:13 2001
+++ ircd-hybrid-6.0/src/m_kline.c	Thu Jul  5 23:24:59 2001
@@ -488,10 +488,11 @@
                         me.name, parv[0], "KLINE");
           return 0;
         }
-      if(temporary_kline_time > (24*60))
-        temporary_kline_time = (24*60); /* Max it at 24 hours */
+      /*       if(temporary_kline_time > (24*60)) */
+      /*         temporary_kline_time = (24*60);*/ /* Max it at 24 hours */ /* No, don't -- asuffield */
       temporary_kline_time_seconds = (time_t)temporary_kline_time * (time_t)60;
-        /* turn it into minutes */
+      /* turn it into minutes */
+      /* turn it into seconds, you mean. it *was* in minutes. -- asuffield */
       argv = parv[2];
       parc--;
     }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_pong.c ircd-hybrid-6.0/src/m_pong.c
--- ircd-hybrid-6.0.orig/src/m_pong.c	Thu Jul  5 23:31:13 2001
+++ ircd-hybrid-6.0/src/m_pong.c	Thu Jul  5 23:30:15 2001
@@ -114,16 +114,6 @@
 
   origin = parv[1];
   destination = parv[2];
-  {
-    struct timeval tv;
-    gettimeofday(&tv, NULL);
-    sptr->ping_time.tv_sec = tv.tv_sec - sptr->ping_send_time.tv_sec;
-    sptr->ping_time.tv_usec = tv.tv_usec - sptr->ping_send_time.tv_usec;
-    if (IsServer(sptr))
-      {
-	sendto_serv_butone(cptr, ":%s SPINGTIME %s %d", me.name, sptr->name, (sptr->ping_time.tv_sec * 1000000) + sptr->ping_time.tv_usec);
-      }
-  }
   cptr->flags &= ~FLAGS_PINGSENT;
   sptr->flags &= ~FLAGS_PINGSENT;
 
@@ -144,14 +134,35 @@
 #endif
 #endif
 
+  if (EmptyString(destination) || irccmp(destination, me.name) == 0)
+    {
+      /* For now we'll only do this extra work when it's a server pong.
+       * Client ping times can be recorded simply be expanding this test
+       * to include clients.
+       *  -- asuffield
+       */
+      if (IsServer(sptr))
+	{
+	  struct timeval tv;
+
+	  gettimeofday(&tv, NULL);
+	  sptr->ping_time.tv_sec = tv.tv_sec - sptr->ping_send_time.tv_sec;
+	  sptr->ping_time.tv_usec = tv.tv_usec - sptr->ping_send_time.tv_usec;
+
+	  if (MyConnect(sptr)) /* This should never fail, with all dancer servers */
+	    {
+	      sendto_serv_butone(cptr, ":%s SPINGTIME %s %d", me.name, sptr->name, 
+				 (sptr->ping_time.tv_sec * 1000000) + sptr->ping_time.tv_usec);
+	    }
+	}
+    }
   /* Now attempt to route the PONG, comstud pointed out routable PING
    * is used for SPING.  routable PING should also probably be left in
    *        -Dianora
    * That being the case, we will route, but only for registered clients (a
    * case can be made to allow them only from servers). -Shadowfax
    */
-  if (!EmptyString(destination) && irccmp(destination, me.name) != 0
-                && IsRegistered(sptr))
+  else if (IsRegistered(sptr))
     {
       if ((acptr = find_client(destination, NULL)) ||
           (acptr = find_server(destination)))
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_cr.c ircd-hybrid-6.0/src/s_cr.c
--- ircd-hybrid-6.0.orig/src/s_cr.c	Thu Jul  5 23:31:13 2001
+++ ircd-hybrid-6.0/src/s_cr.c	Thu Jul  5 23:24:59 2001
@@ -30,9 +30,9 @@
     chall[i] = (c>=10) ? (c - 10 + 'A' ) : (c + '0');
   }
   chall[16]=0;
-  sendto_one(cptr, "CHALL %s %s %s :TS", me.name, chall, get_salt(n_conf->passwd));
   strncpy_irc(cptr->name, n_conf->name, HOSTLEN);
   strcpy(cptr->passwd, chall);
+  sendto_one(cptr, "CHALL %s %s %s %s :TS", me.name, cptr->name, chall, get_salt(n_conf->passwd));
   SetChallenged(cptr);
   sendto_ops_flag(UMODE_EXTERNAL, "Sent password challenge to %s", cptr->name);
 }
@@ -49,15 +49,35 @@
   ircsprintf(trg + 24, "%08x", * (unsigned int *) &md[12]);
 }
 
+/* Now modified so it doesn't hand out responses to anybody who asks for them
+ *
+ * If either:
+ *  -- I initiated the connection (cptr->serv will be defined)
+ *  -- The remote host has already responded to my challenge correctly
+ * Then (and only then) do I send out a response. If the remote end initiated
+ *  the connection, they must authenticate *first*, so I buffer the response
+ *  in cptr->response and send it on later
+ *
+ *  -- asuffield
+ */
+
 void cr_sendresponse(struct Client * cptr, struct ConfItem * c_conf, char * chall, char* salt) {
   extern char * libshadow_md5_crypt(const char *pw, const char *salt);
+  struct ConfItem* n_conf = find_conf_by_name(cptr->name, CONF_NOCONNECT_SERVER);
   char work[PASSWDLEN*2], hash[36];
   strncpy_irc(work, chall, PASSWDLEN);
   strncpy_irc(work + strlen(work), c_conf->passwd ? libshadow_md5_crypt(c_conf->passwd, salt) : "", PASSWDLEN);
   cr_hashstring(work, hash);
-  sendto_one(cptr, "RESP %s", hash);
-  SetResponded(cptr);
-  sendto_ops_flag(UMODE_EXTERNAL, "Sent password response to %s", cptr->name);
+  if (!IsUnknown(cptr) || (strcmp(cptr->passwd, n_conf->passwd) == 0))
+    {
+      sendto_one(cptr, "RESP %s", hash);
+      SetResponded(cptr);
+      sendto_ops_flag(UMODE_EXTERNAL, "Sent password response to %s", cptr->name);
+    }
+  else
+    {
+      strncpy_irc(cptr->response, hash, 32);
+    }
 }
 
 void cr_gotresponse(struct Client * cptr, char * resp) {
@@ -71,6 +91,14 @@
     if (!strcmp(resp, hash)) {
       strncpy_irc(cptr->passwd, n_conf->passwd, PASSWDLEN);
       sendto_ops_flag(UMODE_SEEROUTING, "Got a good password response from %s", cptr->name);
+      /* OK, do we have a response pending ourself? */
+      if (cptr->response[0] && !Responded(cptr))
+	{
+	  sendto_one(cptr, "RESP %s", cptr->response);
+	  cptr->response[0] = '\0';
+	  SetResponded(cptr);
+	  sendto_ops_flag(UMODE_EXTERNAL, "Sent password response to %s", cptr->name);
+	}
     } else {
       sendto_ops_flag(UMODE_SEEROUTING, "Failed password response from %s", cptr->name);
     }
